diff -uwr sourceold/scripts/engine_vector.h source/scripts/engine_vector.h
--- sourceold/scripts/engine_vector.h	2011-11-28 09:12:59.829890600 +0800
+++ source/scripts/engine_vector.h	2012-05-01 21:07:11.413085900 +0800
@@ -1122,7 +1122,7 @@
 		{
 			char buffer[256];
 			sprintf(buffer, "%d memory leaks found in " __FUNCTION__ "\n", TotalObjectCount - FreeObjectCount);
-			OutputDebugString(buffer);
+			OutputDebugStringA(buffer);
 			// TODO: There are quite a few mem leaks of this kind. Fix them.
 		}
 
diff -uwr sourceold/scripts/engine_weap.cpp source/scripts/engine_weap.cpp
--- sourceold/scripts/engine_weap.cpp	2011-10-11 23:03:09.419921800 +0800
+++ source/scripts/engine_weap.cpp	2012-05-23 10:59:15.286132800 +0800
@@ -44,18 +44,19 @@
 }
 
 
-
+#ifndef TT_EXPORTS
 RENEGADE_FUNCTION
 void C4GameObj::Defuse()
 AT2(0x0070D610,0x0070CBD0);
+#endif
 
 SCRIPTS_API int Get_Current_Bullets(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -81,7 +82,7 @@
 	int at = AmmoDef->AmmoType;
 	if (!Owner && Player && AmmoDef && (1 != at))
 	{
-		TT_FOREACH(object, (SList<SmartGameObj>&)GameObjManager::SmartGameObjList)
+		TT_FOREACH(object, GameObjManager::StarGameObjList)
 		{
 			if (object->Get_Player_Data() == Player)
 			{
@@ -104,11 +105,11 @@
 
 SCRIPTS_API int Get_Current_Clip_Bullets(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -129,11 +130,11 @@
 
 SCRIPTS_API int Get_Current_Total_Bullets(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -160,11 +161,11 @@
 
 SCRIPTS_API int Get_Position_Bullets(GameObject *obj,int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -185,11 +186,11 @@
 
 SCRIPTS_API int Get_Position_Clip_Bullets(GameObject *obj,int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -210,11 +211,11 @@
 
 SCRIPTS_API int Get_Position_Total_Bullets(GameObject *obj, int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -241,11 +242,11 @@
 
 SCRIPTS_API int Get_Bullets(GameObject *obj,const char *weapon)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -273,11 +274,11 @@
 
 SCRIPTS_API int Get_Clip_Bullets(GameObject *obj,const char *weapon)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -305,11 +306,11 @@
 
 SCRIPTS_API int Get_Total_Bullets(GameObject *obj,const char *weapon)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -343,11 +344,11 @@
 
 SCRIPTS_API int Get_Current_Max_Bullets(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -368,11 +369,11 @@
 
 SCRIPTS_API int Get_Current_Clip_Max_Bullets(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -393,11 +394,11 @@
 
 SCRIPTS_API int Get_Current_Total_Max_Bullets(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -424,11 +425,11 @@
 
 SCRIPTS_API int Get_Position_Max_Bullets(GameObject *obj, int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -449,11 +450,11 @@
 
 SCRIPTS_API int Get_Position_Clip_Max_Bullets(GameObject *obj, int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -474,11 +475,11 @@
 
 SCRIPTS_API int Get_Position_Total_Max_Bullets(GameObject *obj,int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -505,11 +506,11 @@
 
 SCRIPTS_API int Get_Max_Bullets(GameObject *obj,const char *weapon)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -537,11 +538,11 @@
 
 SCRIPTS_API int Get_Max_Clip_Bullets(GameObject *obj,const char *weapon)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -569,11 +570,11 @@
 
 SCRIPTS_API int Get_Max_Total_Bullets(GameObject *obj,const char *weapon)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -644,11 +645,11 @@
 
 SCRIPTS_API const WeaponDefinitionClass *Get_Current_Weapon_Definition(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -673,11 +674,11 @@
 
 SCRIPTS_API const WeaponDefinitionClass *Get_Position_Weapon_Definition(GameObject *obj,int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -702,7 +703,11 @@
 
 SCRIPTS_API const char *Get_Powerup_Weapon_By_Obj(GameObject *Powerup)
 {
-	const DefinitionClass *powerupdef = Get_Definition(Powerup);
+	if (!Powerup)
+	{
+		return "None";
+	}
+	const DefinitionClass *powerupdef = &Powerup->Get_Definition();
 	PowerUpGameObjDef *c = (PowerUpGameObjDef *)powerupdef;
 	if (!c)
 	{
@@ -718,11 +723,11 @@
 
 SCRIPTS_API int Get_Current_Weapon_Style(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -743,11 +748,11 @@
 
 SCRIPTS_API int Get_Position_Weapon_Style(GameObject *obj, int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -768,11 +773,11 @@
 
 SCRIPTS_API int Get_Weapon_Style(GameObject *obj,const char *weapon)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -800,11 +805,11 @@
 
 SCRIPTS_API void Disarm_Beacon(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return;
@@ -820,11 +825,11 @@
 
 SCRIPTS_API GameObject *Get_Beacon_Planter(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -855,7 +860,7 @@
 }
 
 
-BeaconGameObj* Find_Nearest_Beacon(const Vector3& position, int team)
+SCRIPTS_API BeaconGameObj* Find_Nearest_Beacon(const Vector3& position, int team)
 {
 	BeaconGameObj* beacon = nullptr;
 	float min_distance = std::numeric_limits<float>::infinity();
@@ -882,11 +887,11 @@
 
 SCRIPTS_API void Disarm_C4(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return;
@@ -981,35 +986,35 @@
 
 SCRIPTS_API const char *Get_Current_Weapon(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
-		return 0;
+		return "None";
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
-		return 0;
+		return "None";
 	}
 	ArmedGameObj *o3 = o2->As_ArmedGameObj();
 	if (!o3)
 	{
-		return 0;
+		return "None";
 	}
 	WeaponBagClass *w = o3->Get_Weapon_Bag();
 	if ((w->Get_Index()) && (w->Get_Index() < w->Get_Count()))
 	{
 		return w->Peek_Weapon(w->Get_Index())->Get_Name();
 	}
-	return 0;
+	return "None";
 }
 
 SCRIPTS_API int Get_Weapon_Count(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -1025,35 +1030,35 @@
 
 SCRIPTS_API const char *Get_Weapon(GameObject *obj,int position)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
-		return 0;
+		return "None";
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
-		return 0;
+		return "None";
 	}
 	ArmedGameObj *o3 = o2->As_ArmedGameObj();
 	if (!o3)
 	{
-		return 0;
+		return "None";
 	}
 	WeaponBagClass *w = o3->Get_Weapon_Bag();
 	if ((position) && (position < w->Get_Count()))
 	{
 		return (w->Peek_Weapon(position)->Get_Name());
 	}
-	return 0;
+	return "None";
 }
 
 SCRIPTS_API bool Has_Weapon(GameObject *obj,const char *weapon)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -1136,11 +1141,11 @@
 
 SCRIPTS_API int Get_C4_Mode(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -1155,11 +1160,11 @@
 
 SCRIPTS_API GameObject *Get_C4_Planter(GameObject *obj)
 {	
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -1175,11 +1180,11 @@
 
 SCRIPTS_API GameObject *Get_C4_Attached(GameObject *obj)
 {	
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	PhysicalGameObj *o2 = ((ScriptableGameObj *)obj)->As_PhysicalGameObj();
+	PhysicalGameObj *o2 = obj->As_PhysicalGameObj();
 	if (!o2)
 	{
 		return 0;
@@ -1193,12 +1198,12 @@
 	return (GameObject *)o3->Get_Stuck_Object();
 }
 
-WeaponClass* ArmedGameObj::Get_Weapon()
+SCRIPTS_API WeaponClass* ArmedGameObj::Get_Weapon()
 {
 	return WeaponBag->Get_Weapon();
 }
 
-int	WeaponClass::Get_Total_Rounds()
+SCRIPTS_API int	WeaponClass::Get_Total_Rounds()
 {
 	if (InventoryRounds < 0)
 	{
@@ -1207,7 +1212,7 @@
 	return ClipRounds + InventoryRounds;
 }
 
-float WeaponClass::Get_Range( void )
+SCRIPTS_API float WeaponClass::Get_Range( void )
 {
 	return ( PrimaryAmmoDefinition != NULL ) ? PrimaryAmmoDefinition->Range : 0;
 }
diff -uwr sourceold/scripts/engine_weap.h source/scripts/engine_weap.h
--- sourceold/scripts/engine_weap.h	2011-10-11 21:53:12.073242100 +0800
+++ source/scripts/engine_weap.h	2012-05-23 11:32:21.548828100 +0800
@@ -15,7 +15,7 @@
 class AmmoDefinitionClass;
 class WeaponDefinitionClass;
 class ExplosionDefinitionClass;
-
+class BeaconGameObj;
 SCRIPTS_API int Get_Current_Bullets(GameObject *obj); //Get loaded bullets for an objects current gun
 SCRIPTS_API int Get_Current_Clip_Bullets(GameObject *obj); //Get clip/backpack bullets for an objects current gun
 SCRIPTS_API int Get_Current_Total_Bullets(GameObject *obj); //Get total bullets for an objects current gun
@@ -72,5 +72,5 @@
 SCRIPTS_API GameObject *Get_C4_Planter(GameObject *obj); //Gets the planter of a C4GameObj
 SCRIPTS_API GameObject *Get_C4_Attached(GameObject *obj); //Gets the object a C4GameObj is attached to (if any)
 SCRIPTS_API GameObject *Get_Beacon_Planter(GameObject *obj); //Gets the planter of a BeaconGameObj
-
+SCRIPTS_API BeaconGameObj* Find_Nearest_Beacon(const Vector3& position, int team); //Find the nearest beacon to a position
 #endif
diff -uwr sourceold/scripts/gmbuilding.cpp source/scripts/gmbuilding.cpp
--- sourceold/scripts/gmbuilding.cpp	2011-10-11 23:04:38.933593700 +0800
+++ source/scripts/gmbuilding.cpp	2012-04-24 13:34:24.211914000 +0800
@@ -85,7 +85,12 @@
 							Create_2D_WAV_Sound_Team("m00bnol_dsgn0008i1evan_snd.wav",team);
 							Commands->Start_Timer(obj,this,30.0f,22223);
 						}
-						else if (Is_VehicleFactory(obj))
+						else
+						{
+							BuildingGameObj *b = obj->As_BuildingGameObj();
+							if (b)
+							{
+								if (b->As_WarFactoryGameObj())
 						{
 							char repairmsg[250];
 							const char *bld = Get_Translated_Preset_Name_Ex(obj);
@@ -102,7 +107,7 @@
 							}
 							Commands->Start_Timer(obj,this,30.0f,22223);
 						}
-						else if (Is_SoldierFactory(obj))
+								else if (b->As_SoldierFactoryGameObj())
 						{
 							char repairmsg[250];
 							const char *bld = Get_Translated_Preset_Name_Ex(obj);
@@ -111,7 +116,7 @@
 							delete[] bld;
 							if (team == 0)
 							{
-								Create_2D_WAV_Sound_Team("m00bnhn_dsgn0016i1evan_snd.wav",team);
+										Create_2D_WAV_Sound_Team("m00bnhn_dsgn0015i1evag_snd.wav",team);
 							}
 							else if (team == 1)
 							{
@@ -119,7 +124,7 @@
 							}
 							Commands->Start_Timer(obj,this,30.0f,22223);
 						}
-						else if (Is_Refinery(obj))
+								else if (b->As_RefineryGameObj())
 						{
 							char repairmsg[250];
 							const char *bld = Get_Translated_Preset_Name_Ex(obj);
@@ -136,7 +141,7 @@
 							}
 							Commands->Start_Timer(obj,this,30.0f,22223);
 						}
-						else if (Is_PowerPlant(obj))
+								else if (b->As_PowerPlantGameObj())
 						{
 							char repairmsg[250];
 							const char *bld = Get_Translated_Preset_Name_Ex(obj);
@@ -159,6 +164,8 @@
 		}
 	}
 }
+	}
+}
 
 void SSGM_Building::Timer_Expired(GameObject *obj, int number)
 {
@@ -214,7 +221,7 @@
 	delete[] str;
 	delete[] str2;
 
-	if ( (Is_ConstructionYard(obj)) || (Is_Script_Attached(obj,"TDA_ConYard_Controller")) )
+	if ( ((obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_ConstructionYardGameObj())) || (Is_Script_Attached(obj,"TDA_ConYard_Controller")) )
 	{
 		if (Get_Object_Type(obj) == 1)
 		{
@@ -227,7 +234,7 @@
 			Create_2D_WAV_Sound_Team("m00bncy_kill0002i1evag_snd.wav",1);
 		}
 	}
-	else if (Is_ComCenter(obj))
+	else if (obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_ComCenterGameObj())
 	{
 		if (Get_Object_Type(obj) == 1)
 		{
@@ -240,7 +247,7 @@
 			Create_2D_WAV_Sound_Team("m00bncc_kill0002i1evag_snd.wav",1);
 		}
 	}
-	else if (Is_RepairBay(obj))
+	else if (obj->As_BuildingGameObj() && obj->As_BuildingGameObj()->As_RepairBayGameObj())
 	{
 		if (Get_Object_Type(obj) == 1)
 		{
